/*-------------------------------------------------------*/
/* puissances d'un entier, mthodes nave et dichotomique*/
/*----------------LG novembre 2004-----------------------*/
/*-------------------------------------------------------*/

#include<stdio.h>

int puiss_naive(int x, int n)
{
  int i;
  int res = 1;
  for (i=0;i<=n-1;i++)
    {
      res = res * x;
    }
  return res;
}


int puiss_dicho(int x, int n)
{
  int  k,puiss,res;
  if (n==0) 
    {return 1;}
  else
    {
      if (n==1)
	{
	  return x;
	}
      else
	{
	  res = 1;
	  puiss = x;
	  k=n;
	  while(k>1)
	    {
	      if (k%2 == 1) 
		{
		  res =res*puiss;
		}
	      puiss = puiss*puiss;
	      k = k/2;
	    }
	  return res*puiss;
	}
    }
}

int main(void)
{
  printf("%d puissance %d = %d\n",2,4,puiss_naive(2,4));
/*crit  2 puissance 4 = 16 */

  printf("%d puissance %d = %d\n",2,4,puiss_dicho(2,4));
/*crit  2 puissance 4 = 16 */

  return 0;
}
/*------------------------*/
/*puissances d'une matrice*/
/*---LG novembre 2004-----*/
/*------------------------*/


#include<stdio.h>
#define N 4/*taille des matrices*/

/*tire un entier au hasard entre inf et sup */
int hasard(int inf, int sup)
{
  int rando = rand();
  return (inf + (rando % (sup - inf +1)));
}

/*saisie d'une matrice par l'utilisateur*/
int saisie(int mat[N][N])
{
  int i,j;
  for (i=0;i<N;i++) /* pour toute ligne*/
    {
      for (j=0;j<N;j++) /*pour tout indice de colonne*/
	{
	  printf("case(%d,%d) = ?\n",i,j);
	  scanf("%d",&mat[i][j]);
	}
    }
}

/*genere une matrice au hasard*/
void generation_mat(int mat[N][N])
{
  int i,j;
  for (i=0;i<N;i++) /* pour toute ligne*/
    {
      for (j=0;j<N;j++) /*pour tout indice de colonne*/
	{
	  mat[i][j] = hasard(1,30); 
/*la case i,j recoit un nb au hasard entre 1 et 30 compris*/
	}
    }
}

/*impression d'une matrice*/
/*on suppose que les cases sont <100*/
int impression(int mat[N][N])
{
  int i,j;
  for (i=0;i<N;i++) /* pour toute ligne*/
    {
      for (j=0;j<N;j++) /*pour tout indice de colonne*/
	{
	  /*si <10, j'imprime un espace de plus*/
	  if (mat[i][j]<10) 
	    {
	      printf(" %d ",mat[i][j]);
	    }
	  else
	    {
	      printf("%d ",mat[i][j]);
	    }
	}
      printf("\n");
    }
}


/*multiplication de 2 matrices*/
void mult(int A[N][N], int B[N][N], int C[N][N])
{
  int i,j,k,tmp;
  for (i=0;i<N;i++)
    {
      for (j=0;j<N;j++)
	{
	  tmp = 0;
	  for (k=0;k<N;k++)
	    {
	      tmp = tmp+(A[i][k]*B[k][j]);
	    }
	  C[i][j] = tmp;
	}
    }
}


/*fait la matrice identite d'ordre N*/
void mat_id(int Id[N][N])
{
  int i,j;
  for (i=0;i<N;i++)
    {
      for (j=0;j<N;j++)
	{
	  if (j==i) 
	    {
	      Id[i][j] = 1;
	    }
	  else 
	    {
	      Id[i][j] =0;
	    }
	}
    }
}

/*copie de la matrice A dans la matrice R*/
void copie(int A[N][N], int R[N][N])
{
  int i,j;
  for (i=0;i<N;i++)
    {
      for (j=0;j<N;j++)
	{
	  R[i][j] = A[i][j];
	}
    }
}

/*procdure nave*/
void puiss_naive(int A[N][N], int n, int R[N][N])
{
  int k;
  if (n==0) 
    {
      mat_id(R);
    }
  else
    {
      if (n==1)
	{
	  copie(A,R);
	}
      else
	{
	  copie(A,R);	  
	  for (k=2;k<=n;k++) 
	    {
	      mult(A,R,R);
	    }
	}
    }
}

/*procedure dichotomique*/
void puiss_dicho(int A[N][N], int n, int R[N][N])
{ 
  int k;
  int puiss[N][N];
  int res[N][N];
  
  if (n == 0)
    {
      mat_id(R);
    }
  else 
    {
      if (n==1)
	{
	  copie(A,R);
	}
      else
	{
	  mat_id(res);
	  copie(A,puiss);
	  k = n;
	  while (k>1) 
	    {
	      if (k%2 ==1)
		{
		  mult(res,puiss,res);
		  k = k/2;
		}
	      mult(puiss,puiss,puiss);
	    }
	  mult(res,puiss,R);
	}
    }
}


int main(void)
{
  int m[N][N];
  int r[N][N];

  generation_mat(m);
  impression(m);
  /*pour N=10*/
/* 14 17 28 26 24 26 17 13 10  2  */
/*  3  8 21 20 24 17  1  7 23 17  */
/* 12  9 28 10  3 21  3 14  8 26  */
/* 30 13 13 19 30 28 14 17  2 23  */
/* 10  4 22 30 15  8  9 15  6  1  */
/* 24 17  2 21 27  4  3 21 17  2  */
/* 16 16 15 28 27  6 17 10 14 18  */
/* 25 16 13 16 15 28 15 15  4 21  */
/*  8 19  7  9  9 25  4 12 15 20  */
/* 13  1 27 19 20 23 17  7 25 30 */

  mat_id(m);
  impression(m);
/*  pour N=4  */
/*  1  0  0  0  */
/*  0  1  0  0  */
/*  0  0  1  0  */
/*  0  0  0  1  */

  saisie(m);
  impression(m);
  puiss_naive(m,3,r);
  printf("\n");
  impression(r);
  /* pour n = 4*/
/*  1  0  0  0  */
/*  0  2  0  0  */
/*  0  0  3  0  */
/*  0  0  0  1 */
 
/*  1  0  0  0  */
/*  0  8  0  0  */
/*  0  0 27  0  */
/*  0  0  0  1 */

  mat_id(r);
  puiss_dicho(m,3,r);
  impression(r);
/*  1  0  0  0  */
/*  0  8  0  0  */
/*  0  0 27  0  */
/*  0  0  0  1 */

  return 0;
}
